アンドゥマネージャー

SpreadJSでは、undoStackとredoStackの取得をサポートしており、undoManagerの maxSize メソッドを使用して、undoStackとredoStackのサイズを設定することができます。

説明
app.js
index.html
data.js
styles.css

SpreadJSのredoStackは、getRedoStack メソッドで取得できます。

    var spread = GC.Spread.Sheets.findControl(document.getElementById('ss'));
    let redoStack = spread.undoManager().getRedoStack();

SpreadJSのundoStackは、getUndoStack メソッドで取得できます。

    var spread = GC.Spread.Sheets.findControl(document.getElementById('ss'));
    let undoStack = spread.undoManager().getUndoStack();

redoStack/undoStackの最大サイズは、maxSize メソッドで取得または設定することができます。 Undo/Redoの数がスタックのサイズを超える場合は、スタックの先頭が削除され、新たなアクションがスタックの最後に追加されます。

    var spread = GC.Spread.Sheets.findControl(document.getElementById('ss'));
    let undoManager = spread.undoManager();
    undoManager.maxSize(20); // set max size.
    let maxSize = undoManager.maxSize(); // get max size. 
SpreadJSのredoStackは、getRedoStack メソッドで取得できます。 SpreadJSのundoStackは、getUndoStack メソッドで取得できます。 redoStack/undoStackの最大サイズは、maxSize メソッドで取得または設定することができます。 Undo/Redoの数がスタックのサイズを超える場合は、スタックの先頭が削除され、新たなアクションがスタックの最後に追加されます。
window.onload = function () { var spread = new GC.Spread.Sheets.Workbook(_getElementById('ss')); initSpread(spread); } function initSpread(spread) { spread.fromJSON(data[0]); var sheet = spread.getActiveSheet(); attachEvent(spread); executeCommand(spread); updateInfo(spread); } function attachEvent(spread) { var events = GC.Spread.Sheets.Events; spread.bind(events.ValueChanged, updateInfoHandle); spread.bind(events.ViewZoomed, updateInfoHandle); spread.bind(events.ColumnChanged, updateInfoHandle); spread.bind(events.ColumnWidthChanged, updateInfoHandle); spread.bind(events.RowChanged, updateInfoHandle); spread.bind(events.RowHeightChanged, updateInfoHandle); let setButton = _getElementById("gc-max-size-set"); let maxSizeDom = _getElementById("gc-max-size"); let redoButton = _getElementById("gc-redo-button"); let undoButton = _getElementById("gc-undo-button"); let undoManager = spread.undoManager(); setButton.addEventListener("click", () => { let value = Number(maxSizeDom.value); if (!isNaN(value)) { spread.undoManager().maxSize(value); } }) redoButton.addEventListener("click", () => { undoManager.redo(); updateInfo(spread); }) undoButton.addEventListener("click", () => { undoManager.undo(); updateInfo(spread); }) } function executeCommand(spread) { var commandManager = spread.commandManager(); let sheet = spread.getActiveSheet(); let sheetName = sheet.name(); spread.suspendPaint() commandManager.execute({ cmd: "resizeColumn", sheetName: sheetName, size: 70, rowHeader: false, columns: [{ firstCol: 0, lastCol: 5 }], }); commandManager.execute({ cmd: "editCell", sheetName: sheetName, row: 0, col: 0, newValue: "Edit Cell", autoFormat: true, }); commandManager.execute({ cmd: "resizeRow", sheetName: sheetName, rows: [{ firstRow: 0, lastRow: 5, }], size: 30, columnHeader: false, }) spread.undoManager().undo(); spread.resumePaint(); } function updateInfoHandle(sender, info) { var sheet = info.sheet; var spread = sheet.parent; updateInfo(spread); } function updateInfo(spread) { var undoManager = spread.undoManager(); setTimeout(() => { updateUndoInfo(undoManager); updateRedoInfo(undoManager); }, 0); } function updateUndoInfo(undoManager) { var undoStack = undoManager.getUndoStack(); var description = getDescription(undoStack); let undoContainer = _getElementById("gc-undo-stack-container"); undoContainer.value = description; } function updateRedoInfo(undoManager) { var redoStack = undoManager.getRedoStack(); let description = getDescription(redoStack); let redoContainer = _getElementById("gc-redo-stack-container"); redoContainer.value = description; } function getDescription(actionStack) { let description = ""; for (var i = 0; i < actionStack.length; i++) { description = description + (i + 1) + '.' + actionStack[i].cmd + "\r\n"; } return description; } function _getElementById(id) { return document.getElementById(id); }
<!doctype html> <html lang="en" style="height:100%;font-size:14px;"> <head> <meta name="spreadjs culture" content="ja-jp" /> <meta charset="utf-8" /> <meta name="viewport" content="width=device-width, initial-scale=1.0" /> <link rel="stylesheet" type="text/css" href="$DEMOROOT$/ja/purejs/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css"> <link rel="stylesheet" type="text/css" href="styles.css"> <script src="$DEMOROOT$/ja/purejs/node_modules/@mescius/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script> <script src="$DEMOROOT$/ja/purejs/node_modules/@mescius/spread-sheets-resources-ja/dist/gc.spread.sheets.resources.ja.min.js" type="text/javascript"></script> <script src="app.js" type="text/javascript"></script> <script src="data.js" type="text/javascript"></script> <script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script> </head> <body> <div class="sample-tutorial"> <!-- Workbook host element --> <div id="ss" class="sample-spreadsheets"></div> <div class="options-container"> <div class="option-row"> <input type="button" value="Redo(やり直し)" class="gc-stack-button" id="gc-redo-button"> <input type="button" value="Undo(取り消し)" class="gc-stack-button" id="gc-undo-button"> </div> <div class="gc-undo-stack-container option-row"> <label>現在undoStackには以下のコマンドがあります。</label> <textarea type="text" class="gc-stack-list" id="gc-undo-stack-container" cols="30"></textarea> </div> <div class="gc-redo-stack-container option-row"> <label>現在redoStackには以下のコマンドがあります。</label> <textarea type="text" class="gc-stack-list" id="gc-redo-stack-container" cols="30"></textarea> </div> <div class="option-row"> <label>Undo/Redo スタックの最大サイズを設定します。</label> <input type="number" min="0" max="2147483647" id="gc-max-size" class="gc-max-size" value="10"> <input type="button" id="gc-max-size-set" value="設定"> </div> </div> </div> </body> </html>
var data = [{ "version":"12.0.0", "tabStripRatio":0.6, "sheetCount":1, "sheets":{ "Sheet1":{ "name":"Sheet1", "rowCount":114, "columnCount":21, "activeRow":2, "activeCol":2, "data":{ "dataTable":{ "2":{ "2":{ "value":"Student", "style": { "foreColor" : "#FFFFFF", "backColor" : "#82BC00", "hAlign" : 1 } }, "3":{ "value":"Language", "style": { "foreColor" : "#FFFFFF", "backColor" : "#82BC00", "hAlign" : 1 } }, "4":{ "value":"Math", "style": { "foreColor" : "#FFFFFF", "backColor" : "#82BC00", "hAlign" : 1 } }, "5":{ "value":"Science", "style": { "foreColor" : "#FFFFFF", "backColor" : "#82BC00", "hAlign" : 1 } }, "6":{ "value":"Music", "style": { "foreColor" : "#FFFFFF", "backColor" : "#82BC00", "hAlign" : 1 } }, "7":{ "value":"History", "style": { "foreColor" : "#FFFFFF", "backColor" : "#82BC00", "hAlign" : 1 } } }, "3":{ "2":{ "value":"Ally", "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "3":{ "value":95.2, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "4":{ "value":65.2, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "5":{ "value":75.2, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "6":{ "value":95.2, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "7":{ "value":91.8, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} } }, "4":{ "2":{ "value":"Tom", "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "3":{ "value":81.8, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "4":{ "value":95.2, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "5":{ "value":95, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "6":{ "value":75.2, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "7":{ "value":88, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} } }, "5":{ "2":{ "value":"Jack", "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "3":{ "value":95.2, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "4":{ "value":68.2, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "5":{ "value":65.2, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "6":{ "value":88, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "7":{ "value":79, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} } }, "6":{ "2":{ "value":"John", "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "3":{ "value":68.2, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "4":{ "value":81.8, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "5":{ "value":86, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "6":{ "value":75, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "7":{ "value":86, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} } }, "7":{ "2":{ "value":"Lily", "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "3":{ "value":95.2, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "4":{ "value":65.2, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "5":{ "value":95.2, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "6":{ "value":95.2, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "7":{ "value":91.8, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} } }, "8":{ "2":{ "value":"Linda", "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "3":{ "value":75.2, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "4":{ "value":95.2, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "5":{ "value":88, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "6":{ "value":65.2, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "7":{ "value":65.2, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} } }, "9":{ "2":{ "value":"Will", "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "3":{ "value":95.2, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "4":{ "value":94.8, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "5":{ "value":94, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "6":{ "value":55.2, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} }, "7":{ "value":88, "style":{"backColor" : "#F4F8EB", "hAlign" : 1} } } } }, } } }]
.sample-tutorial { position: relative; height: 100%; overflow: hidden; } body { position: absolute; top: 0; bottom: 0; left: 0; right: 0; } .sample-spreadsheets { width: calc(100% - 280px); height: 100%; overflow: hidden; float: left; } .options-container{ float: right; width: 280px; padding: 12px; height: 100%; box-sizing: border-box; background: #fbfbfb; overflow: auto; } .option-row { font-size: 14px; padding: 5px; margin-top: 10px; } .gc-stack-list{ width: 100%; height: 150px; margin-top: 10px; } .gc-stack-button{ margin: 0 5px; }

SpreadJSのredoStackは、getRedoStack メソッドで取得できます。
SpreadJSのundoStackは、getUndoStack メソッドで取得できます。
redoStack/undoStackの最大サイズは、maxSize メソッドで取得または設定することができます。
Undo/Redoの数がスタックのサイズを超える場合は、スタックの先頭が削除され、新たなアクションがスタックの最後に追加されます。
import * as React from 'react';
import * as ReactDOM from 'react-dom';
import './styles.css';
import { AppFunc } from './app-func';
import { App } from './app-class';
// 1. Functional Component sample
ReactDOM.render(<AppFunc />, document.getElementById('app'));
// 2. Class Component sample
// ReactDOM.render(<App />, document.getElementById('app'));
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-resources-ja';
GC.Spread.Common.CultureManager.culture("ja-jp");
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
import { getData } from './data';
function _getElementById(id) {
return document.getElementById(id);
}
export function AppFunc() {
const initSpread = (spread) => {
spread.fromJSON(getData()[0]);
attachEvents(spread);
executeCommand(spread);
_getElementById("gc-max-size").value = 10;
updateInfo(spread);
}
const attachEvents = (spread) => {
const events = GC.Spread.Sheets.Events;
spread.bind(events.ValueChanged, () => updateInfo(spread));
spread.bind(events.ViewZoomed, () => updateInfo(spread));
spread.bind(events.ColumnChanged, () => updateInfo(spread));
spread.bind(events.ColumnWidthChanged, () => updateInfo(spread));
spread.bind(events.RowChanged, () => updateInfo(spread));
spread.bind(events.RowHeightChanged, () => updateInfo(spread));
const setButton = _getElementById("gc-max-size-set");
const maxSizeDom = _getElementById("gc-max-size");
const redoButton = _getElementById("gc-redo-button");
const undoButton = _getElementById("gc-undo-button");
const undoManager = spread.undoManager();
setButton.addEventListener("click", () => {
const value = Number(maxSizeDom.value);
if (!isNaN(value)) {
spread.undoManager().maxSize(value);
}
});
redoButton.addEventListener("click", () => {
undoManager.redo();
updateInfo(spread);
});
undoButton.addEventListener("click", () => {
undoManager.undo();
updateInfo(spread);
});
}
const executeCommand = (spread) => {
const commandManager = spread.commandManager();
const sheet = spread.getActiveSheet();
const sheetName = sheet.name();
commandManager.execute({
cmd: "resizeColumn",
sheetName: sheetName,
size: 70,
rowHeader: false,
columns: [{
firstCol: 0,
lastCol: 5
}],
});
commandManager.execute({
cmd: "editCell",
sheetName: sheetName,
row: 0,
col: 0,
newValue: "Edit Cell",
autoFormat: true,
});
commandManager.execute({
cmd: "resizeRow",
sheetName: sheetName,
rows: [{
firstRow: 0,
lastRow: 5,
}],
size: 30,
columnHeader: false,
})
spread.undoManager().undo();
}
const updateInfo = (spread) => {
const undoManager = spread.undoManager();
setTimeout(() => {
updateUndoInfo(undoManager);
updateRedoInfo(undoManager);
}, 0);
}
const updateUndoInfo = (undoManager) => {
const undoStack = undoManager.getUndoStack();
const description = getDescription(undoStack);
const undoContainer = _getElementById("gc-undo-stack-container");
undoContainer.value = description;
}
const updateRedoInfo = (undoManager) => {
const redoStack = undoManager.getRedoStack();
const description = getDescription(redoStack);
const redoContainer = _getElementById("gc-redo-stack-container");
redoContainer.value = description;
}
const getDescription = (actionStack) => {
let description = "";
for (let i = 0; i < actionStack.length; i++) {
description = description + (i + 1) + "." + actionStack[i].cmd + "\r\n";
}
return description;
}
return <div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => initSpread(spread)}>
<Worksheet></Worksheet>
</SpreadSheets>
</div>
<div class="options-container">
<div class="option-row">
<input type="button" value="Redo(やり直し)" class="gc-redo" id="gc-redo-button" />
<input type="button" value="Undo(取り消し)" class="gc-undo" id="gc-undo-button" />
</div>
<div class="gc-undo-stack-container option-row">
<label>現在undoStackには以下のコマンドがあります。</label>
<textarea type="text" class="gc-stack-list" id="gc-undo-stack-container" cols="30"></textarea>
</div>
<div class="gc-redo-stack-container option-row">
<label>現在redoStackには以下のコマンドがあります。</label>
<textarea type="text" class="gc-stack-list" id="gc-redo-stack-container" cols="30"></textarea>
</div>
<div class="option-row">
<label>Undo/Redo スタックの最大サイズを設定します。</label>
<input type="number" min="0" max="2147483647" id="gc-max-size" class="gc-max-size" />
<input type="button" id="gc-max-size-set" value="set" />
</div>
</div>
</div>
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-resources-ja';
GC.Spread.Common.CultureManager.culture("ja-jp");
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
import './styles.css';
import { getData } from './data';
const Component = React.Component;
function _getElementById(id) {
return document.getElementById(id);
}
export class App extends Component {
constructor(props) {
super(props);
this.spread = null;
}
render() {
return <div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
<Worksheet></Worksheet>
</SpreadSheets>
</div>
<div class="options-container">
<div class="option-row">
<input type="button" value="Redo(やり直し)" class="gc-redo" id="gc-redo-button" />
<input type="button" value="Undo(取り消し)" class="gc-undo" id="gc-undo-button" />
</div>
<div class="gc-undo-stack-container option-row">
<label>現在undoStackには以下のコマンドがあります。</label>
<textarea type="text" class="gc-stack-list" id="gc-undo-stack-container" cols="30"></textarea>
</div>
<div class="gc-redo-stack-container option-row">
<label>現在redoStackには以下のコマンドがあります。</label>
<textarea type="text" class="gc-stack-list" id="gc-redo-stack-container" cols="30"></textarea>
</div>
<div class="option-row">
<label>Undo/Redo スタックの最大サイズを設定します。</label>
<input type="number" min="0" max="2147483647" id="gc-max-size" class="gc-max-size" />
<input type="button" id="gc-max-size-set" value="set" />
</div>
</div>
</div>
}
initSpread(spread) {
this.spread = spread;
spread.fromJSON(getData()[0]);
this.attachEvents();
this.executeCommand();
_getElementById("gc-max-size").value = 10;
this.updateInfo();
}
attachEvents() {
var spread = this.spread;
var events = GC.Spread.Sheets.Events;
spread.bind(events.ValueChanged, this.updateInfo.bind(this));
spread.bind(events.ViewZoomed, this.updateInfo.bind(this));
spread.bind(events.ColumnChanged, this.updateInfo.bind(this));
spread.bind(events.ColumnWidthChanged, this.updateInfo.bind(this));
spread.bind(events.RowChanged, this.updateInfo.bind(this));
spread.bind(events.RowHeightChanged, this.updateInfo.bind(this));
let setButton = _getElementById("gc-max-size-set");
let maxSizeDom = _getElementById("gc-max-size");
let redoButton = _getElementById("gc-redo-button");
let undoButton = _getElementById("gc-undo-button");
let undoManager = spread.undoManager();
setButton.addEventListener("click", () => {
let value = Number(maxSizeDom.value);
if (!isNaN(value)) {
spread.undoManager().maxSize(value);
}
});
redoButton.addEventListener("click", () => {
undoManager.redo();
this.updateInfo();
});
undoButton.addEventListener("click", () => {
undoManager.undo();
this.updateInfo();
});
}
executeCommand() {
var spread = this.spread;
var commandManager = spread.commandManager();
let sheet = spread.getActiveSheet();
let sheetName = sheet.name();
commandManager.execute({
cmd: "resizeColumn",
sheetName: sheetName,
size: 70,
rowHeader: false,
columns: [{
firstCol: 0,
lastCol: 5
}],
});
commandManager.execute({
cmd: "editCell",
sheetName: sheetName,
row: 0,
col: 0,
newValue: "Edit Cell",
autoFormat: true,
});
commandManager.execute({
cmd: "resizeRow",
sheetName: sheetName,
rows: [{
firstRow: 0,
lastRow: 5,
}],
size: 30,
columnHeader: false,
})
spread.undoManager().undo();
}
updateInfo() {
var undoManager = this.spread.undoManager();
setTimeout(() => {
this.updateUndoInfo(undoManager);
this.updateRedoInfo(undoManager);
}, 0);
}
updateUndoInfo(undoManager) {
var undoStack = undoManager.getUndoStack();
var description = this.getDescription(undoStack);
let undoContainer = _getElementById("gc-undo-stack-container");
undoContainer.value = description;
}
updateRedoInfo(undoManager) {
var redoStack = undoManager.getRedoStack();
let description = this.getDescription(redoStack);
let redoContainer = _getElementById("gc-redo-stack-container");
redoContainer.value = description;
}
getDescription(actionStack) {
let description = "";
for (var i = 0; i < actionStack.length; i++) {
description = description + (i + 1) + "." + actionStack[i].cmd + "\r\n";
}
return description;
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/ja/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/ja/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/ja/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container{
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
.gc-stack-list{
width: 100%;
height: 150px;
margin-top: 10px;
}
#app {
height: 100%;
}
.gc-stack-button{
margin: 0 5px;
}
export function getData(){
var data = [{
"version":"12.0.0",
"tabStripRatio":0.6,
"sheetCount":1,
"sheets":{
"Sheet1":{
"name":"Sheet1",
"rowCount":114,
"columnCount":21,
"activeRow":2,
"activeCol":2,
"data":{
"dataTable":{
"2":{
"2":{
"value":"Student",
"style":
{
"foreColor" : "#FFFFFF",
"backColor" : "#82BC00",
"hAlign" : 1
}
},
"3":{
"value":"Language",
"style": {
"foreColor" : "#FFFFFF",
"backColor" : "#82BC00",
"hAlign" : 1
}
},
"4":{
"value":"Math",
"style": {
"foreColor" : "#FFFFFF",
"backColor" : "#82BC00",
"hAlign" : 1
}
},
"5":{
"value":"Science",
"style": {
"foreColor" : "#FFFFFF",
"backColor" : "#82BC00",
"hAlign" : 1
}
},
"6":{
"value":"Music",
"style": {
"foreColor" : "#FFFFFF",
"backColor" : "#82BC00",
"hAlign" : 1
}
},
"7":{
"value":"History",
"style": {
"foreColor" : "#FFFFFF",
"backColor" : "#82BC00",
"hAlign" : 1
}
}
},
"3":{
"2":{
"value":"Ally",
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"3":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"4":{
"value":65.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"5":{
"value":75.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"6":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"7":{
"value":91.8,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
}
},
"4":{
"2":{
"value":"Tom",
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"3":{
"value":81.8,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"4":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"5":{
"value":95,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"6":{
"value":75.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"7":{
"value":88,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
}
},
"5":{
"2":{
"value":"Jack",
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"3":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"4":{
"value":68.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"5":{
"value":65.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"6":{
"value":88,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"7":{
"value":79,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
}
},
"6":{
"2":{
"value":"John",
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"3":{
"value":68.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"4":{
"value":81.8,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"5":{
"value":86,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"6":{
"value":75,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"7":{
"value":86,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
}
},
"7":{
"2":{
"value":"Lily",
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"3":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"4":{
"value":65.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"5":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"6":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"7":{
"value":91.8,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
}
},
"8":{
"2":{
"value":"Linda",
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"3":{
"value":75.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"4":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"5":{
"value":88,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"6":{
"value":65.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"7":{
"value":65.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
}
},
"9":{
"2":{
"value":"Will",
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"3":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"4":{
"value":94.8,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"5":{
"value":94,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"6":{
"value":55.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"7":{
"value":88,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
}
}
}
},
}
}
}];
return data;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ja': 'npm:@mescius/spread-sheets-resources-ja/index.js',
'@mescius/spread-sheets-react': 'npm:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/umd/react.production.min.js',
'react-dom': 'npm:react-dom/umd/react-dom.production.min.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

SpreadJSのredoStackは、getRedoStack メソッドで取得できます。
SpreadJSのundoStackは、getUndoStack メソッドで取得できます。
redoStack/undoStackの最大サイズは、maxSize メソッドで取得または設定することができます。
Undo/Redoの数がスタックのサイズを超える場合は、スタックの先頭が削除され、新たなアクションがスタックの最後に追加されます。
<template>
<div class="sample-tutorial">
<!-- Workbook host element -->
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet> </gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<div class="option-row">
<input type="button" value="Redo(やり直し)" class="gc-redo" id="gc-redo-button" />
<input type="button" value="Undo(取り消し)" class="gc-undo" id="gc-undo-button" />
</div>
<div class="gc-undo-stack-container option-row">
<label>現在undoStackには以下のコマンドがあります。</label>
<textarea type="text" class="gc-stack-list" id="gc-undo-stack-container" cols="30"></textarea>
</div>
<div class="gc-redo-stack-container option-row">
<label>現在redoStackには以下のコマンドがあります。</label>
<textarea type="text" class="gc-stack-list" id="gc-redo-stack-container" cols="30"></textarea>
</div>
<div class="option-row">
<label>Undo/Redo スタックの最大サイズを設定します。</label>
<input type="number" min="0" max="2147483647" id="gc-max-size" class="gc-max-size" value="10" />
<input type="button" id="gc-max-size-set" value="set" />
</div>
</div>
</div>
</template>
<script setup>
import { shallowRef, watch } from "vue";
import "@mescius/spread-sheets-vue";
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-resources-ja';
GC.Spread.Common.CultureManager.culture("ja-jp");
import "./data.js";
let mySpread;
let initSpread = function (spread) {
mySpread = spread;
attachEvent();
executeCommand();
updateInfo();
}
function attachEvent() {
var spread = mySpread;
spread.fromJSON(data[0]);
var events = GC.Spread.Sheets.Events;
spread.bind(events.ValueChanged, updateInfo);
spread.bind(events.ViewZoomed, updateInfo);
spread.bind(events.ColumnChanged, updateInfo);
spread.bind(events.ColumnWidthChanged, updateInfo);
spread.bind(events.RowChanged, updateInfo);
spread.bind(events.RowHeightChanged, updateInfo);
let setButton = _getElementById("gc-max-size-set");
let maxSizeDom = _getElementById("gc-max-size");
let redoButton = _getElementById("gc-redo-button");
let undoButton = _getElementById("gc-undo-button");
let undoManager = spread.undoManager();
setButton.addEventListener("click", () => {
let value = Number(maxSizeDom.value);
if (!isNaN(value)) {
spread.undoManager().maxSize(value);
}
});
redoButton.addEventListener("click", () => {
undoManager.redo();
updateInfo(spread);
});
undoButton.addEventListener("click", () => {
undoManager.undo();
updateInfo(spread);
});
}
function executeCommand() {
var spread = mySpread;
var commandManager = spread.commandManager();
let sheet = spread.getActiveSheet();
let sheetName = sheet.name();
commandManager.execute({
cmd: "resizeColumn",
sheetName: sheetName,
size: 70,
rowHeader: false,
columns: [{
firstCol: 0,
lastCol: 5
}],
});
commandManager.execute({
cmd: "editCell",
sheetName: sheetName,
row: 0,
col: 0,
newValue: "Edit Cell",
autoFormat: true,
});
commandManager.execute({
cmd: "resizeRow",
sheetName: sheetName,
rows: [{
firstRow: 0,
lastRow: 5,
}],
size: 30,
columnHeader: false,
})
spread.undoManager().undo();
}
function updateInfo() {
var undoManager = mySpread.undoManager();
setTimeout(() => {
updateUndoInfo(undoManager);
updateRedoInfo(undoManager);
}, 0);
}
function updateUndoInfo(undoManager) {
var undoStack = undoManager.getUndoStack();
var description = getDescription(undoStack);
let undoContainer = _getElementById("gc-undo-stack-container");
undoContainer.value = description;
}
function updateRedoInfo(undoManager) {
var redoStack = undoManager.getRedoStack();
let description = getDescription(redoStack);
let redoContainer = _getElementById("gc-redo-stack-container");
redoContainer.value = description;
}
function getDescription(actionStack) {
let description = "";
for (var i = 0; i < actionStack.length; i++) {
description = description + (i + 1) + "." + actionStack[i].cmd + "\r\n";
}
return description;
}
function _getElementById(id) {
return document.getElementById(id);
}
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
.gc-stack-list {
width: 100%;
height: 150px;
margin-top: 10px;
}
.gc-stack-button {
margin: 0 5px;
}
</style>
<!DOCTYPE html>
<html lang="en" style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/ja/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/ja/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script src="$DEMOROOT$/spread/source/data/outlineColumn-wbs.js" type="text/javascript"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/ja/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
var data = [{
"version":"12.0.0",
"tabStripRatio":0.6,
"sheetCount":1,
"sheets":{
"Sheet1":{
"name":"Sheet1",
"rowCount":114,
"columnCount":21,
"activeRow":2,
"activeCol":2,
"data":{
"dataTable":{
"2":{
"2":{
"value":"Student",
"style":
{
"foreColor" : "#FFFFFF",
"backColor" : "#82BC00",
"hAlign" : 1
}
},
"3":{
"value":"Language",
"style": {
"foreColor" : "#FFFFFF",
"backColor" : "#82BC00",
"hAlign" : 1
}
},
"4":{
"value":"Math",
"style": {
"foreColor" : "#FFFFFF",
"backColor" : "#82BC00",
"hAlign" : 1
}
},
"5":{
"value":"Science",
"style": {
"foreColor" : "#FFFFFF",
"backColor" : "#82BC00",
"hAlign" : 1
}
},
"6":{
"value":"Music",
"style": {
"foreColor" : "#FFFFFF",
"backColor" : "#82BC00",
"hAlign" : 1
}
},
"7":{
"value":"History",
"style": {
"foreColor" : "#FFFFFF",
"backColor" : "#82BC00",
"hAlign" : 1
}
}
},
"3":{
"2":{
"value":"Ally",
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"3":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"4":{
"value":65.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"5":{
"value":75.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"6":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"7":{
"value":91.8,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
}
},
"4":{
"2":{
"value":"Tom",
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"3":{
"value":81.8,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"4":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"5":{
"value":95,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"6":{
"value":75.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"7":{
"value":88,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
}
},
"5":{
"2":{
"value":"Jack",
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"3":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"4":{
"value":68.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"5":{
"value":65.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"6":{
"value":88,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"7":{
"value":79,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
}
},
"6":{
"2":{
"value":"John",
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"3":{
"value":68.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"4":{
"value":81.8,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"5":{
"value":86,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"6":{
"value":75,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"7":{
"value":86,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
}
},
"7":{
"2":{
"value":"Lily",
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"3":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"4":{
"value":65.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"5":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"6":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"7":{
"value":91.8,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
}
},
"8":{
"2":{
"value":"Linda",
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"3":{
"value":75.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"4":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"5":{
"value":88,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"6":{
"value":65.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"7":{
"value":65.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
}
},
"9":{
"2":{
"value":"Will",
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"3":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"4":{
"value":94.8,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"5":{
"value":94,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"6":{
"value":55.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"7":{
"value":88,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
}
}
}
},
}
}
}];
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-ja': 'npm:@mescius/spread-sheets-resources-ja/index.js',
'@mescius/spread-sheets-vue': 'npm:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

SpreadJSのredoStackは、getRedoStack メソッドで取得できます。
SpreadJSのundoStackは、getUndoStack メソッドで取得できます。
redoStack/undoStackの最大サイズは、maxSize メソッドで取得または設定することができます。
Undo/Redoの数がスタックのサイズを超える場合は、スタックの先頭が削除され、新たなアクションがスタックの最後に追加されます。
import { Component, NgModule, enableProdMode } from '@angular/core';
import { bootstrapApplication, BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import { getData } from './app.data';
import GC from '@mescius/spread-sheets';
import '@mescius/spread-sheets-resources-ja';
GC.Spread.Common.CultureManager.culture("ja-jp");
import './styles.css';
function _getElementById(id:string) {
return document.getElementById(id);
}
@Component({
standalone: true,
imports: [SpreadSheetsModule, BrowserModule],
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
autoGenerateColumns = false;
spread: GC.Spread.Sheets.Workbook;
hostStyle = {
width: '100%',
height: '100%'
};
constructor() {
}
initSpread($event: any) {
this.spread = $event.spread;
this.attachEvents();
this.executeCommand();
this.updateInfo();
}
attachEvents() {
var spread = this.spread;
spread.fromJSON(getData()[0]);
var events = GC.Spread.Sheets.Events;
spread.bind(events.ValueChanged, this.updateInfo.bind(this));
spread.bind(events.ViewZoomed, this.updateInfo.bind(this));
spread.bind(events.ColumnChanged, this.updateInfo.bind(this));
spread.bind(events.ColumnWidthChanged, this.updateInfo.bind(this));
spread.bind(events.RowChanged, this.updateInfo.bind(this));
spread.bind(events.RowHeightChanged, this.updateInfo.bind(this));
let setButton = _getElementById("gc-max-size-set");
let maxSizeDom = _getElementById("gc-max-size") as HTMLInputElement;
let redoButton = _getElementById("gc-redo-button") as HTMLTextAreaElement;
let undoButton = _getElementById("gc-undo-button") as HTMLTextAreaElement;
let undoManager = spread.undoManager();
setButton.addEventListener("click", () => {
let value = Number(maxSizeDom.value);
if (!isNaN(value)) {
spread.undoManager().maxSize(value);
}
});
redoButton.addEventListener("click", () => {
undoManager.redo();
this.updateInfo();
});
undoButton.addEventListener("click", () => {
undoManager.undo();
this.updateInfo();
});
}
executeCommand() {
var spread = this.spread;
var commandManager = spread.commandManager();
let sheet = spread.getActiveSheet();
let sheetName = sheet.name();
commandManager.execute({
cmd: "resizeColumn",
sheetName: sheetName,
size: 70,
rowHeader: false,
columns: [{
firstCol: 0,
lastCol: 5
}],
});
commandManager.execute({
cmd: "editCell",
sheetName: sheetName,
row: 0,
col: 0,
newValue: "Edit Cell",
autoFormat: true,
});
commandManager.execute({
cmd: "resizeRow",
sheetName: sheetName,
rows: [{
firstRow: 0,
lastRow: 5,
}],
size: 30,
columnHeader: false,
})
spread.undoManager().undo();
}
updateInfo() {
var undoManager = this.spread.undoManager();
setTimeout(() => {
this.updateUndoInfo(undoManager);
this.updateRedoInfo(undoManager);
}, 0);
}
updateUndoInfo(undoManager:any) {
var undoStack = undoManager.getUndoStack();
var description = this.getDescription(undoStack);
let undoContainer = _getElementById("gc-undo-stack-container") as HTMLTextAreaElement;
undoContainer.value = description;
}
updateRedoInfo(undoManager:any) {
var redoStack = undoManager.getRedoStack();
let description = this.getDescription(redoStack);
let redoContainer = _getElementById("gc-redo-stack-container") as HTMLTextAreaElement;
redoContainer.value = description;
}
getDescription(actionStack:any[]) {
let description = "";
for (var i = 0; i < actionStack.length; i++) {
description = description + (i + 1) + "." + actionStack[i].cmd + "\r\n";
}
return description;
}
}
enableProdMode();
bootstrapApplication(AppComponent);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/ja/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/ja/angular/node_modules/core-js/client/shim.min.js"></script>
<script src="$DEMOROOT$/ja/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/ja/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/ja/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<!-- Workbook host element -->
<div id="ss" class="sample-spreadsheets">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet [dataSource]="dataSource" [autoGenerateColumns]='autoGenerateColumns'>
<gc-column dataField="Film" width=160></gc-column>
<gc-column dataField="Genre" width=70></gc-column>
<gc-column dataField="Lead Studio" width=90></gc-column>
<gc-column dataField="Audience Score %" width=110></gc-column>
<gc-column dataField="Profitability" width=80></gc-column>
<gc-column dataField="Rating"></gc-column>
<gc-column dataField="Worldwide Gross" width=110></gc-column>
<gc-column dataField="Year"></gc-column>
</gc-worksheet>
</gc-spread-sheets>
</div>
<div class="options-container">
<div class="option-row">
<input type="button" value="Redo(やり直し)" class="gc-redo" id="gc-redo-button">
<input type="button" value="Undo(取り消し)" class="gc-undo" id="gc-undo-button">
</div>
<div class="gc-undo-stack-container option-row">
<label>現在undoStackには以下のコマンドがあります。</label>
<textarea type="text" class="gc-stack-list" id="gc-undo-stack-container" cols="30"></textarea>
</div>
<div class="gc-redo-stack-container option-row">
<label>現在redoStackには以下のコマンドがあります。</label>
<textarea type="text" class="gc-stack-list" id="gc-redo-stack-container" cols="30"></textarea>
</div>
<div class="option-row">
<label>Undo/Redo スタックの最大サイズを設定します。</label>
<input type="number" min="0" max="2147483647" id="gc-max-size" class="gc-max-size" value="10">
<input type="button" id="gc-max-size-set" value="set">
</div>
</div>
</div>
export function getData(){
var data = [{
"version":"12.0.0",
"tabStripRatio":0.6,
"sheetCount":1,
"sheets":{
"Sheet1":{
"name":"Sheet1",
"rowCount":114,
"columnCount":21,
"activeRow":2,
"activeCol":2,
"data":{
"dataTable":{
"2":{
"2":{
"value":"Student",
"style":
{
"foreColor" : "#FFFFFF",
"backColor" : "#82BC00",
"hAlign" : 1
}
},
"3":{
"value":"Language",
"style": {
"foreColor" : "#FFFFFF",
"backColor" : "#82BC00",
"hAlign" : 1
}
},
"4":{
"value":"Math",
"style": {
"foreColor" : "#FFFFFF",
"backColor" : "#82BC00",
"hAlign" : 1
}
},
"5":{
"value":"Science",
"style": {
"foreColor" : "#FFFFFF",
"backColor" : "#82BC00",
"hAlign" : 1
}
},
"6":{
"value":"Music",
"style": {
"foreColor" : "#FFFFFF",
"backColor" : "#82BC00",
"hAlign" : 1
}
},
"7":{
"value":"History",
"style": {
"foreColor" : "#FFFFFF",
"backColor" : "#82BC00",
"hAlign" : 1
}
}
},
"3":{
"2":{
"value":"Ally",
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"3":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"4":{
"value":65.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"5":{
"value":75.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"6":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"7":{
"value":91.8,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
}
},
"4":{
"2":{
"value":"Tom",
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"3":{
"value":81.8,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"4":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"5":{
"value":95,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"6":{
"value":75.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"7":{
"value":88,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
}
},
"5":{
"2":{
"value":"Jack",
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"3":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"4":{
"value":68.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"5":{
"value":65.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"6":{
"value":88,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"7":{
"value":79,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
}
},
"6":{
"2":{
"value":"John",
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"3":{
"value":68.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"4":{
"value":81.8,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"5":{
"value":86,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"6":{
"value":75,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"7":{
"value":86,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
}
},
"7":{
"2":{
"value":"Lily",
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"3":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"4":{
"value":65.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"5":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"6":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"7":{
"value":91.8,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
}
},
"8":{
"2":{
"value":"Linda",
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"3":{
"value":75.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"4":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"5":{
"value":88,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"6":{
"value":65.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"7":{
"value":65.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
}
},
"9":{
"2":{
"value":"Will",
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"3":{
"value":95.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"4":{
"value":94.8,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"5":{
"value":94,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"6":{
"value":55.2,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
},
"7":{
"value":88,
"style":{"backColor" : "#F4F8EB", "hAlign" : 1}
}
}
}
},
}
}
}];
return data;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container{
float: right;
width: 280px;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
overflow: auto;
}
.option-row {
font-size: 14px;
padding: 5px;
margin-top: 10px;
}
.gc-stack-list{
width: 100%;
height: 150px;
margin-top: 10px;
}
.gc-stack-button{
margin: 0 5px;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/'
},
// map tells the System loader where to look for things
map: {
'core-js': 'npm:core-js/client/shim.min.js',
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'tslib':'npm:tslib/tslib.js',
'@mescius/spread-sheets': 'npm:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'npm:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@mescius/spread-sheets-resources-ja': 'npm:@mescius/spread-sheets-resources-ja/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts',
meta: {
"*.component.ts": {
loader: "system.component-loader.js"
}
}
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);